com.smartgwt.client.widgets.form

## Class FilterClause

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.HStack
            - - com.smartgwt.client.widgets.form.FilterClause

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClearHandlers, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasRuleContextChangedHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasMembersChangedHandlers

      public class FilterClause
      extends HStack

  A horizontal, Layout-based widget that allows a user to input a single criterion based on one field and one operator.

  Note that FilterClauses must be used in conjunction with a `FilterBuilder`. By default the FilterBuilder will auto-generate its clauses based on specified criteria, but for advanced usage a FilterClause may be instantiated directly and passed to a filterBuilder via `FilterBuilder.addClause()`.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilterClause()`
    `FilterClause(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `SearchForm` | `getClause()` AutoChild containing the UI for the filter-properties in this FilterClause.
    `Criteria` | `getCriterion()` Initial criterion for this FilterClause.
    `FormItem` | `getFieldPickerProperties()` Properties to combine with the `FieldPicker` autoChild FormItem.
    `java.lang.String` | `getFieldPickerTitle()` The title for the `field-picker` select-item.
    `void` | `getFilterBuilder()` Returns the `filterBuilder` containing this clause, or null if this filterClause is not embedded in a filterBuilder.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `SelectItem` | `getOperatorPicker()` AutoChild for the `FormItem` that allows a user to select the operator when creating filter clauses.
    `FormItem` | `getOperatorPickerProperties()` Properties to combine with the `operatorPicker` autoChild FormItem.
    `java.lang.String` | `getOperatorPickerTitle()` The title for the operator-picker select-item.
    `static FilterClause` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `ImgButton` | `getRemoveButton()` The clause removal ImgButton that appears before this clause if `showRemoveButton` is set.
    `java.lang.String` | `getRemoveButtonPrompt()` The hover prompt text for the remove button.
    `java.lang.Boolean` | `getShowFieldTitles()` If true (the default), show field titles in the drop-down box used to select a field for querying.
    `java.lang.Boolean` | `getShowRemoveButton()` If set, show a button for this clause allowing it to be removed.
    `java.lang.Boolean` | `getValidateOnChange()` If true (the default), validates the entered value when it changes, to make sure it is a a valid value of its type (valid string, number, and so on).
    `java.lang.String` | `getValueItemFieldHint()` A hint to show in the value-item when using an operator that allows users to select field-names from a list.
    `java.lang.String` | `getValueItemListHint()` A hint to show in the value-item when using an operator that allows users to select values from a list.
    `java.lang.String` | `getValueItemTextHint()` A hint to show in the value-item when using an operator that takes user-entered values.
    `java.lang.String` | `getValueItemTitle()` The title for the value-item.
    `java.lang.String` | `getValueSetHint()` A hint to show in the value-item when using an operator that takes an array of values.
    `void` | `remove()` Remove this clause by destroy()ing it.
    `FilterClause` | `setCriterion(Criteria criterion)` Initial criterion for this FilterClause.
    `static void` | `setDefaultProperties(FilterClause filterClauseProperties)` Class level method to set the default properties of this class.
    `FilterClause` | `setFieldPickerProperties(FormItem fieldPickerProperties)` Properties to combine with the `FieldPicker` autoChild FormItem.
    `FilterClause` | `setFieldPickerTitle(java.lang.String fieldPickerTitle)` The title for the `field-picker` select-item.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.form.FilterClauseLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `FilterClause` | `setOperatorPickerProperties(FormItem operatorPickerProperties)` Properties to combine with the `operatorPicker` autoChild FormItem.
    `FilterClause` | `setOperatorPickerTitle(java.lang.String operatorPickerTitle)` The title for the operator-picker select-item.
    `FilterClause` | `setRemoveButtonPrompt(java.lang.String removeButtonPrompt)` The hover prompt text for the remove button.
    `FilterClause` | `setShowFieldTitles(java.lang.Boolean showFieldTitles)` If true (the default), show field titles in the drop-down box used to select a field for querying.
    `FilterClause` | `setShowRemoveButton(java.lang.Boolean showRemoveButton)` If set, show a button for this clause allowing it to be removed.
    `FilterClause` | `setValidateOnChange(java.lang.Boolean validateOnChange)` If true (the default), validates the entered value when it changes, to make sure it is a a valid value of its type (valid string, number, and so on).
    `FilterClause` | `setValueItemFieldHint(java.lang.String valueItemFieldHint)` A hint to show in the value-item when using an operator that allows users to select field-names from a list.
    `FilterClause` | `setValueItemListHint(java.lang.String valueItemListHint)` A hint to show in the value-item when using an operator that allows users to select values from a list.
    `FilterClause` | `setValueItemTextHint(java.lang.String valueItemTextHint)` A hint to show in the value-item when using an operator that takes user-entered values.
    `FilterClause` | `setValueItemTitle(java.lang.String valueItemTitle)` The title for the value-item.
    `FilterClause` | `setValueSetHint(java.lang.String valueSetHint)` A hint to show in the value-item when using an operator that takes an array of values.
    `java.lang.Boolean` | `validate()` Validate this clause.

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.HStack

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAutoMaskComponents, getAutoParent, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCorrectZoomOverflow, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getTabIndex, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDragMask, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeFonts, resizeFonts, resizeFonts, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCorrectZoomOverflow, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setTabIndex, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDragMask, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### FilterClause

          public FilterClause()

    - #### FilterClause

          public FilterClause(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static FilterClause getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `HStack`

    - #### getClause

          public SearchForm getClause()
                               throws java.lang.IllegalStateException

      AutoChild containing the UI for the filter-properties in this FilterClause.

      This component is an AutoChild named "clause". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current clause value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setCriterion

          public FilterClause setCriterion(Criteria criterion)

      Initial criterion for this FilterClause.

      When initialized with a criterion, the clause will be automatically set up for editing the supplied criterion.

      Note that an empty or partial criterion is allowed, for example, it may specify `Criterion.fieldName` only and will generate an expression with the operator not chosen.

      Parameters:
        `criterion` - New criterion value. Default value is null
      Returns:
        `FilterClause` instance, for chaining setter calls

    - #### getCriterion

          public Criteria getCriterion()

      Initial criterion for this FilterClause.

      When initialized with a criterion, the clause will be automatically set up for editing the supplied criterion.

      Note that an empty or partial criterion is allowed, for example, it may specify `Criterion.fieldName` only and will generate an expression with the operator not chosen.

      Returns:
        Return the criterion specified by this FilterClause. Default value is null

    - #### setFieldPickerProperties

          public FilterClause setFieldPickerProperties(FormItem fieldPickerProperties)
                                                throws java.lang.IllegalStateException

      Properties to combine with the `FieldPicker` autoChild FormItem.
      Parameters:
        `fieldPickerProperties` - New fieldPickerProperties value. Default value is null
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFieldPickerProperties

          public FormItem getFieldPickerProperties()

      Properties to combine with the `FieldPicker` autoChild FormItem.
      Returns:
        Current fieldPickerProperties value. Default value is null

    - #### setFieldPickerTitle

          public FilterClause setFieldPickerTitle(java.lang.String fieldPickerTitle)
                                           throws java.lang.IllegalStateException

      The title for the `field-picker` select-item.
      Parameters:
        `fieldPickerTitle` - New fieldPickerTitle value. Default value is "Field Name"
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFieldPickerTitle

          public java.lang.String getFieldPickerTitle()

      The title for the `field-picker` select-item.
      Returns:
        Current fieldPickerTitle value. Default value is "Field Name"

    - #### getOperatorPicker

          public SelectItem getOperatorPicker()
                                       throws java.lang.IllegalStateException

      AutoChild for the `FormItem` that allows a user to select the operator when creating filter clauses. Each clause will create an operatorPicker automatically. To customize this item, use `operatorPickerProperties`

      This component is an AutoChild named "operatorPicker". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current operatorPicker value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setOperatorPickerProperties

          public FilterClause setOperatorPickerProperties(FormItem operatorPickerProperties)
                                                   throws java.lang.IllegalStateException

      Properties to combine with the `operatorPicker` autoChild FormItem.
      Parameters:
        `operatorPickerProperties` - New operatorPickerProperties value. Default value is null
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getOperatorPickerProperties

          public FormItem getOperatorPickerProperties()

      Properties to combine with the `operatorPicker` autoChild FormItem.
      Returns:
        Current operatorPickerProperties value. Default value is null

    - #### setOperatorPickerTitle

          public FilterClause setOperatorPickerTitle(java.lang.String operatorPickerTitle)
                                              throws java.lang.IllegalStateException

      The title for the operator-picker select-item.
      Parameters:
        `operatorPickerTitle` - New operatorPickerTitle value. Default value is "Operator"
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getOperatorPickerTitle

          public java.lang.String getOperatorPickerTitle()

      The title for the operator-picker select-item.
      Returns:
        Current operatorPickerTitle value. Default value is "Operator"

    - #### getRemoveButton

          public ImgButton getRemoveButton()
                                    throws java.lang.IllegalStateException

      The clause removal ImgButton that appears before this clause if `showRemoveButton` is set.

      This component is an AutoChild named "removeButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current removeButton value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setRemoveButtonPrompt

          public FilterClause setRemoveButtonPrompt(java.lang.String removeButtonPrompt)
                                             throws java.lang.IllegalStateException

      The hover prompt text for the remove button.
      Parameters:
        `removeButtonPrompt` - New removeButtonPrompt value. Default value is "Remove"
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRemoveButtonPrompt

          public java.lang.String getRemoveButtonPrompt()

      The hover prompt text for the remove button.
      Returns:
        Current removeButtonPrompt value. Default value is "Remove"

    - #### setShowFieldTitles

          public FilterClause setShowFieldTitles(java.lang.Boolean showFieldTitles)
                                          throws java.lang.IllegalStateException

      If true (the default), show field titles in the drop-down box used to select a field for querying. If false, show actual field names instead.
      Parameters:
        `showFieldTitles` - New showFieldTitles value. Default value is true
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowFieldTitles

          public java.lang.Boolean getShowFieldTitles()

      If true (the default), show field titles in the drop-down box used to select a field for querying. If false, show actual field names instead.
      Returns:
        Current showFieldTitles value. Default value is true

    - #### setShowRemoveButton

          public FilterClause setShowRemoveButton(java.lang.Boolean showRemoveButton)
                                           throws java.lang.IllegalStateException

      If set, show a button for this clause allowing it to be removed.
      Parameters:
        `showRemoveButton` - New showRemoveButton value. Default value is true
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowRemoveButton

          public java.lang.Boolean getShowRemoveButton()

      If set, show a button for this clause allowing it to be removed.
      Returns:
        Current showRemoveButton value. Default value is true

    - #### setValidateOnChange

          public FilterClause setValidateOnChange(java.lang.Boolean validateOnChange)
                                           throws java.lang.IllegalStateException

      If true (the default), validates the entered value when it changes, to make sure it is a a valid value of its type (valid string, number, and so on). No other validation is carried out. If you switch this property off, it is still possible to validate the `FilterClause` by calling `validate()` from your own code.
      Parameters:
        `validateOnChange` - New validateOnChange value. Default value is true
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValidateOnChange

          public java.lang.Boolean getValidateOnChange()

      If true (the default), validates the entered value when it changes, to make sure it is a a valid value of its type (valid string, number, and so on). No other validation is carried out. If you switch this property off, it is still possible to validate the `FilterClause` by calling `validate()` from your own code.
      Returns:
        Current validateOnChange value. Default value is true

    - #### setValueItemFieldHint

          public FilterClause setValueItemFieldHint(java.lang.String valueItemFieldHint)
                                             throws java.lang.IllegalStateException

      A hint to show in the value-item when using an operator that allows users to select field-names from a list.
      Parameters:
        `valueItemFieldHint` - New valueItemFieldHint value. Default value is "Select a field"
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueItemFieldHint

          public java.lang.String getValueItemFieldHint()

      A hint to show in the value-item when using an operator that allows users to select field-names from a list.
      Returns:
        Current valueItemFieldHint value. Default value is "Select a field"

    - #### setValueItemListHint

          public FilterClause setValueItemListHint(java.lang.String valueItemListHint)
                                            throws java.lang.IllegalStateException

      A hint to show in the value-item when using an operator that allows users to select values from a list.
      Parameters:
        `valueItemListHint` - New valueItemListHint value. Default value is "Select a value"
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueItemListHint

          public java.lang.String getValueItemListHint()

      A hint to show in the value-item when using an operator that allows users to select values from a list.
      Returns:
        Current valueItemListHint value. Default value is "Select a value"

    - #### setValueItemTextHint

          public FilterClause setValueItemTextHint(java.lang.String valueItemTextHint)
                                            throws java.lang.IllegalStateException

      A hint to show in the value-item when using an operator that takes user-entered values.
      Parameters:
        `valueItemTextHint` - New valueItemTextHint value. Default value is "Enter a value"
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueItemTextHint

          public java.lang.String getValueItemTextHint()

      A hint to show in the value-item when using an operator that takes user-entered values.
      Returns:
        Current valueItemTextHint value. Default value is "Enter a value"

    - #### setValueItemTitle

          public FilterClause setValueItemTitle(java.lang.String valueItemTitle)
                                         throws java.lang.IllegalStateException

      The title for the value-item.
      Parameters:
        `valueItemTitle` - New valueItemTitle value. Default value is "Value"
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueItemTitle

          public java.lang.String getValueItemTitle()

      The title for the value-item.
      Returns:
        Current valueItemTitle value. Default value is "Value"

    - #### setValueSetHint

          public FilterClause setValueSetHint(java.lang.String valueSetHint)
                                       throws java.lang.IllegalStateException

      A hint to show in the value-item when using an operator that takes an array of values.
      Parameters:
        `valueSetHint` - New valueSetHint value. Default value is "Comma-separated values"
      Returns:
        `FilterClause` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueSetHint

          public java.lang.String getValueSetHint()

      A hint to show in the value-item when using an operator that takes an array of values.
      Returns:
        Current valueSetHint value. Default value is "Comma-separated values"

    - #### getFilterBuilder

          public void getFilterBuilder()

      Returns the `filterBuilder` containing this clause, or null if this filterClause is not embedded in a filterBuilder.

    - #### remove

          public void remove()

      Remove this clause by destroy()ing it.

    - #### validate

          public java.lang.Boolean validate()

      Validate this clause.
      Returns:
        true if if the clause is valid, false otherwise

    - #### setDefaultProperties

          public static void setDefaultProperties(FilterClause filterClauseProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `filterClauseProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.form.FilterClauseLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `HStack`